]> git.kernelconcepts.de Git - karo-tx-uboot.git/blob - dts/Makefile
Unified codebase for TX28, TX48, TX51, TX53
[karo-tx-uboot.git] / dts / Makefile
1 #
2 # Copyright (c) 2011 The Chromium OS Authors.
3 #
4 # See file CREDITS for list of people who contributed to this
5 # project.
6 #
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License as
9 # published by the Free Software Foundatio; either version 2 of
10 # the License, or (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston,
20 # MA 02111-1307 USA
21 #
22
23 # This Makefile builds the internal U-Boot fdt if CONFIG_OF_CONTROL is
24 # enabled. See doc/README.fdt-control for more details.
25
26 include $(TOPDIR)/config.mk
27
28 LIB     = $(obj)libdts.o
29
30 $(if $(CONFIG_DEFAULT_DEVICE_TREE),,\
31 $(error Please define CONFIG_DEFAULT_DEVICE_TREE in your board header file))
32 DEVICE_TREE = $(subst ",,$(CONFIG_DEFAULT_DEVICE_TREE))
33
34 $(if $(CONFIG_ARCH_DEVICE_TREE),,\
35 $(error Your architecture does not have device tree support enabled. \
36 Please define CONFIG_ARCH_DEVICE_TREE))
37
38 # We preprocess the device tree file provide a useful define
39 DTS_CPPFLAGS := -DARCH_CPU_DTS=\"$(SRCTREE)/arch/$(ARCH)/dts/$(CONFIG_ARCH_DEVICE_TREE).dtsi\"
40
41 all:    $(obj).depend $(LIB)
42
43 # Use a constant name for this so we can access it from C code.
44 # objcopy doesn't seem to allow us to set the symbol name independently of
45 # the filename.
46 DT_BIN  := $(obj)dt.dtb
47
48 $(DT_BIN): $(TOPDIR)/board/$(VENDOR)/dts/$(DEVICE_TREE).dts
49         rc=$$( \
50                 cat $< | $(CPP) -P -x assembler-with-cpp $(DTS_CPPFLAGS) - | \
51                 { { $(DTC) -R 4 -p 0x1000 -O dtb -o ${DT_BIN} - >&2 ; \
52                     echo $$? >&3 ; } | \
53                   grep -v '^DTC: dts->dtb  on file' ; \
54                 } 3>&1 ) ; \
55         exit $$rc
56
57 process_lds = \
58         $(1) | sed -r -n 's/^OUTPUT_$(2)[ ("]*([^")]*).*/\1/p'
59
60 # Run the compiler and get the link script from the linker
61 GET_LDS = $(CC) $(CFLAGS) $(LDFLAGS) -Wl,--verbose 2>&1
62
63 $(obj)dt.o: $(DT_BIN)
64         # We want the output format and arch.
65         # We also hope to win a prize for ugliest Makefile / shell interaction
66         # We look in the LDSCRIPT first.
67         # Then try the linker which should give us the answer.
68         # Then check it worked.
69         [ -n "$${LDSCRIPT}" ] && oformat=`$(call process_lds,cat $(LDSCRIPT),FORMAT)` &&\
70                 oarch=`$(call process_lds,cat $(LDSCRIPT),ARCH)` ;\
71         [ -z "$${oformat}" ] && \
72                 oformat=`$(call process_lds,$(GET_LDS),FORMAT)` ;\
73         [ -z "$${oarch}" ] && \
74                 oarch=`$(call process_lds,$(GET_LDS),ARCH)` ;\
75         \
76         [ -z "$${oformat}" ] && \
77                 echo "Cannot read OUTPUT_FORMAT from lds file $(LDSCRIPT)" && \
78                 exit 1 || true ;\
79         [ -z "$${oarch}" ] && \
80                 echo "Cannot read OUTPUT_ARCH from lds file $(LDSCRIPT)" && \
81                 exit 1 || true ;\
82         \
83         cd $(dir ${DT_BIN}) && \
84         $(OBJCOPY) -I binary -O $${oformat} -B $${oarch} \
85                 $(notdir ${DT_BIN}) $@
86         rm $(DT_BIN)
87
88 OBJS-$(CONFIG_OF_EMBED) := dt.o
89
90 COBJS   := $(OBJS-y)
91
92 OBJS    := $(addprefix $(obj),$(COBJS))
93
94 binary: $(DT_BIN)
95
96 $(LIB): $(OBJS) $(DTB)
97         $(call cmd_link_o_target, $(OBJS))
98
99 #########################################################################
100
101 # defines $(obj).depend target
102 include $(SRCTREE)/rules.mk
103
104 sinclude $(obj).depend
105
106 #########################################################################